-----------------------------------------------------------------------------------------------
-- Client Lua Script for ChatEmotes
-- Andrej@Jabbit
-- Updated Sweet@Jabbit
-- Updated Synaya@Jabbit
-- Updated Benisuzume@Jabbit
-- RooEmote By AdmiralBahroo@Twitch
-- muhEmote By FlareRDB@Twitch
-----------------------------------------------------------------------------------------------
require "Apollo"
require "Sound"
 
-----------------------------------------------------------------------------------------------
-- ChatEmotes Module Definition
-----------------------------------------------------------------------------------------------
local ChatEmotes = {} 
 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
local tEmoticons = {
	[":)"] = { sprite="ChatEmotes:1" },
	[":("] = { sprite="ChatEmotes:2" },
	[":o"] = { sprite="ChatEmotes:3" },
	[":O"] = { sprite="ChatEmotes:3" },
	[":z"] = { sprite="ChatEmotes:4" },
	[":Z"] = { sprite="ChatEmotes:4" },
	["-.-"] = { sprite="ChatEmotes:4" },
	["B)"] = { sprite="ChatEmotes:5" },
	[":/"] = { sprite="ChatEmotes:6" },
	[";)"] = { sprite="ChatEmotes:7" },
	[";p"] = { sprite="ChatEmotes:8" },
	[";P"] = { sprite="ChatEmotes:8" },
	[":p"] = { sprite="ChatEmotes:9" },
	[":P"] = { sprite="ChatEmotes:9" },
	["R)"] = { sprite="ChatEmotes:10" },
	["o_O"] = { sprite="ChatEmotes:11" },
	[":D"] = { sprite="ChatEmotes:12" },
	[">("] = { sprite="ChatEmotes:13" },
	[">.<"] = { sprite="ChatEmotes:13" },
	["<3"] = { sprite="ChatEmotes:14" },
	["BibleThump"] = { sprite="ChatEmotes:15" },
	["FrankerZ"] = { sprite="ChatEmotes:16" },
	["KAPOW"] = { sprite="ChatEmotes:17" },
	["Kappa"] = { sprite="ChatEmotes:18" },
	["Keepo"] = { sprite="ChatEmotes:19" },
	["Kreygasm"] = { sprite="ChatEmotes:20" },
	["PJSalt"] = { sprite="ChatEmotes:21" },
	["ResidentSleeper"] = { sprite="ChatEmotes:22" },
	["RalpherZ"] = { sprite="ChatEmotes:23" },
	["PoohBear"] = { sprite="ChatEmotes:24" },
	["Pooh"] = { sprite="ChatEmotes:24" },
	["pooh"] = { sprite="ChatEmotes:24" },
	["FailFish"] = { sprite="ChatEmotes:25" },
	["OpieOP"] = { sprite="ChatEmotes:26" },
	["SwiftRage"] = { sprite="ChatEmotes:27" },
	["lirikThump"] = { sprite="ChatEmotes:28" },
	["PedoBear"] = { sprite="ChatEmotes:29" },
	["4Head"] = { sprite="ChatEmotes:30" },
	["DansGame"] = { sprite="ChatEmotes:31" },
	["MrDestructoid"] = { sprite="ChatEmotes:32" },
	["BabyRage"] = { sprite="ChatEmotes:33" },
	["lnuBrick"] = { sprite="ChatEmotes:34" },
	["Briex"] = { sprite="ChatEmotes:34" },
	["Brieq"] = { sprite="ChatEmotes:34" },
	["BloodTrail"] = { sprite="ChatEmotes:35" },
	["TheThing"] = { sprite="ChatEmotes:36" },
	["TriHard"] = { sprite="ChatEmotes:37" },
	["ConcernDoge"] = { sprite="ChatEmotes:38" },
	["DogeWitIt"] = { sprite="ChatEmotes:39" },
	["GabeN"] = { sprite="ChatEmotes:40" },
	["zybakFace"] = { sprite="ChatEmotes:41" },
	["riPepperonis"] = { sprite="ChatEmotes:42" },
	["Rekt"] = { sprite="ChatEmotes:43" },
	["trkPopcorn"] = { sprite="ChatEmotes:44" },
	["PogChamp"] = { sprite="ChatEmotes:45" },
	["acouGrill"] = { sprite="ChatEmotes:46" },
	["wickedFedora"] = { sprite="ChatEmotes:47" },
	["zorzPray"] = { sprite="ChatEmotes:48" },
	["badHype"] = { sprite="ChatEmotes:49" },
	["danRekt"] = { sprite="ChatEmotes:50" },
	["neoMustache"] = { sprite="ChatEmotes:51" },
	["sigRESET"] = { sprite="ChatEmotes:52", width=66 },
	["SMOrc"] = { sprite="ChatEmotes:53" },
	["krippDonger"] = { sprite="ChatEmotes:54" },
	["rwgStayTrue"] = { sprite="ChatEmotes:55" },
	["rwgLetItGo"] = { sprite="ChatEmotes:56" },
	["lleucaRNG"] = { sprite="ChatEmotes:57" },
	["letoRNGesus"] = { sprite="ChatEmotes:58" },
	["pashaBajceps"] = { sprite="ChatEmotes:59" },
	["sodaRIP"] = { sprite="ChatEmotes:60" },
	["HeyGuys"] = { sprite="ChatEmotes:61" },
	["FlaskOfSpeed"] = { sprite="ChatEmotes:62" },
	["zybakWIPE"] = { sprite="ChatEmotes:63" },
	["rwgLIGHTS"] = { sprite="ChatEmotes:64" },
	["esperaldaFace"] = { sprite="ChatEmotes:65" },
	["espeFace"] = { sprite="ChatEmotes:65" },
	["tenriFace"] = { sprite="ChatEmotes:66", sound="tenri-mathematician" },
	["ViciousFace"] = { sprite="ChatEmotes:67" },
	["koraFace"] = { sprite="ChatEmotes:68" },
	["benFace"] = { sprite="ChatEmotes:69" },
	["GigaFace"] = { sprite="ChatEmotes:70" },
	["gigaFace"] = { sprite="ChatEmotes:71" },
	["moGod"] = { sprite="ChatEmotes:72" },
	["vimFace"] = { sprite="ChatEmotes:73" },
	["VimFace"] = { sprite="ChatEmotes:74" },
	["walrusFace"] = { sprite="ChatEmotes:75" },
	["vairaFace"] = { sprite="ChatEmotes:76" },
	["LilZ"] = { sprite="ChatEmotes:76" },
	["ZreknarF"] = { sprite="ChatEmotes:77" },
	["KaneFace"] = { sprite="ChatEmotes:78" },
	["TenriFace"] = { sprite="ChatEmotes:79" },
	["hasanFace"] = { sprite="ChatEmotes:80" },
	["kaneFace"] = { sprite="ChatEmotes:81" },
	["HasanFace"] = { sprite="ChatEmotes:82" },
	["YuullFace"] = { sprite="ChatEmotes:83", sound="yuull-carrying_retards" },
	["itsyFace"] = { sprite="ChatEmotes:84" },
	["byonaFace"] = { sprite="ChatEmotes:85", sound="byona-allah_short" },
	["ByonaFace"] = { sprite="ChatEmotes:86", sound="byona-allah_long" },
	["kiritoFace"] = { sprite="ChatEmotes:87" },
	["viciousFace"] = { sprite="ChatEmotes:88" },
	["yanaFace"] = { sprite="ChatEmotes:89" },
	["bitchFace"] = { sprite="ChatEmotes:90" },
	["kungenFace"] = { sprite="ChatEmotes:91" },
	["KinaeFace"] = { sprite="ChatEmotes:92" },
	["kinaeFace"] = { sprite="ChatEmotes:93" },
	["tailOffFace"] = { sprite="ChatEmotes:94" },
	["mindBlown"] = { sprite="ChatEmotes:95" },
	["LootRage"] = { sprite="ChatEmotes:96" },
	["lootRage"] = { sprite="ChatEmotes:97" },
	["BrokeBack"] = { sprite="ChatEmotes:98" },
	["lirikAppa"] = { sprite="ChatEmotes:99" },
	["lirikCLENCH"] = { sprite="ChatEmotes:100" },
	["lirikMLG"] = { sprite="ChatEmotes:101" },
	["lirikTEN"] = { sprite="ChatEmotes:102" },
	["moreDots"] = { sprite="ChatEmotes:103" },
	["MoreDots"] = { sprite="ChatEmotes:104" },
	["KrippDonger"] = { sprite="ChatEmotes:106" },
	["lokohhFood"] = { sprite="ChatEmotes:107" },
	["PJLokohh"] = { sprite="ChatEmotes:108" },
	["eleGiggle"] = { sprite="ChatEmotes:109" },
	["nippeFace"] = { sprite="ChatEmotes:110" },
	["nipFace"] = { sprite="ChatEmotes:110" },
	["lirikREKT"] = { sprite="ChatEmotes:111" },
	["lirikRIP"] = { sprite="ChatEmotes:112" },
	["lirikGasm"] = { sprite="ChatEmotes:113" },
	["lirikH"] = { sprite="ChatEmotes:114" },
	["lirikHug"] = { sprite="ChatEmotes:115" },
	["lirikTRASH"] = { sprite="ChatEmotes:116" },
	["lirikPOOP"] = { sprite="ChatEmotes:117" },
	["panicBasket"] = { sprite="ChatEmotes:118" },
	["duDudu"] = { sprite="ChatEmotes:119" },
	["EleGiggle"] = { sprite="ChatEmotes:120" },
	["WutFace"] = { sprite="ChatEmotes:121" },
	["wutFace"] = { sprite="ChatEmotes:122" },
	["KappaPride"] = { sprite="ChatEmotes:123" },
	["VaultBoy"] = { sprite="ChatEmotes:124" },
	["CodexFace"] = { sprite="ChatEmotes:125" },
	["CoolCat"] = { sprite="ChatEmotes:126" },
	["abuxFace"] = { sprite="ChatEmotes:127" },
	["AbuxFace"] = { sprite="ChatEmotes:128" },
	["RareMing"] = { sprite="ChatEmotes:129" },
	["deIlluminati"] = { sprite="ChatEmotes:130" },
	["MichaelPls"] = { sprite="ChatEmotes:131" },
	["MingLee"] = { sprite="ChatEmotes:132" },
	["mingLee"] = { sprite="ChatEmotes:133" },
	["AngelThump"] = { sprite="ChatEmotes:134", width=56 },
	["FeelsGoodMan"] = { sprite="ChatEmotes:136" },
	["FeelsBadMan"] = { sprite="ChatEmotes:137" },
	["FeelsBirthdayMan"] = { sprite="ChatEmotes:138" },
	["KKona"] = { sprite="ChatEmotes:139" },
	["RebeccaBlack"] = { sprite="ChatEmotes:140" },
	["OhMyGoodness"] = { sprite="ChatEmotes:141" },
	["Citto"] = { sprite="ChatEmotes:142", sound="konga" },
	["(ditto)"] = { sprite="ChatEmotes:143", width=18 },
	["Ditto"] = { sprite="ChatEmotes:143", width=18 },
	["KappaRoss"] = { sprite="ChatEmotes:144" },
	["NotLikeThis"] = { sprite="ChatEmotes:145" },
	["JohnCena"] = { sprite="ChatEmotes:146", sound="JohnCena" },
	["Hanzo"] = { sprite="ChatEmotes:147", sound="Hanzo" },
	["KappaClaus"] = { sprite="ChatEmotes:148" },
	["Stitch"] = { sprite="ChatEmotes:149", sound="Stitch" },
	["prezFace"] = { sprite="ChatEmotes:150" },
	["aariFace"] = { sprite="ChatEmotes:151", sound="aari-smash" },
	["zaidraFace"] = { sprite="ChatEmotes:152" },
	["bykkFace"] = { sprite="ChatEmotes:153" },
	["TTFace"] = { sprite="ChatEmotes:154" },
	["AariWitIt"] = { sprite="ChatEmotes:155" },
	["cojamoFace"] = { sprite="ChatEmotes:156", sound="cojamo-spacebar" },
	["CojamoFace"] = { sprite="ChatEmotes:157" },
	["lokohhFace"] = { sprite="ChatEmotes:158", sound="lokohh-the_cock" },
	["LokohhFace"] = { sprite="ChatEmotes:159" },
	["nikalliFace"] = { sprite="ChatEmotes:160" },
	["NikalliFace"] = { sprite="ChatEmotes:161" },
	["walzyFace"] = { sprite="ChatEmotes:162", sound="walzy-3rd_world_retard" },
	["WalzyFace"] = { sprite="ChatEmotes:163" },
	["yuullFace"] = { sprite="ChatEmotes:164" },
	["scultiFace"] = { sprite="ChatEmotes:165" },
	["scultiQQ"] = { sprite="ChatEmotes:166" },
	["ANELE"] = { sprite="ChatEmotes:167" },
	["CorgiDerp"] = { sprite="ChatEmotes:168" },
	["KappaWealth"] = { sprite="ChatEmotes:169" },
	["PartyTime"] = { sprite="ChatEmotes:170" },
	["DogFace"] = { sprite="ChatEmotes:171" },
	["VoHiYo"] = { sprite="ChatEmotes:172" },
	["OhMyDog"] = { sprite="ChatEmotes:173" },
	["cmonBruh"] = { sprite="ChatEmotes:174" },
	["VapeNation"] = { sprite="ChatEmotes:175" },
	["eloiseWb"] = { sprite="ChatEmotes:176" },
	["LUL"] = { sprite="ChatEmotes:177" },
	["cookieFace"] = { sprite="ChatEmotes:178" },
	["cookieH"] = { sprite="ChatEmotes:179" },
	["cookieGASM"] = { sprite="ChatEmotes:180" },
	["cookieRIP"] = { sprite="ChatEmotes:181" },
	["NootNoot"] = { sprite="ChatEmotes:182", sound="noot" },
	["CoolPepe"] = { sprite="ChatEmotes:183" },
	["monkaS"] = { sprite="ChatEmotes:184" },
	["Ohmna"] = { sprite="ChatEmotes:185" },
	["Mooscles"] = { sprite="ChatEmotes:186", sound="poompmooscles" },
	["howlFace"] = { sprite="ChatEmotes:187" },
	["RIPChair"] = { sprite="ChatEmotes:188" },
	["thinking"] = { sprite="ChatEmotes:189" },
	["NootCena"] = { sprite="ChatEmotes:190", sound="nootcena" },
	["RareParrot"] = { sprite="ChatEmotes:191" },
	["gloParrot"] = { sprite="ChatEmotes:192" },
	["Yee"] = { sprite="ChatEmotes:193", sound="yee" },
	["shyrilFace"] = { sprite="ChatEmotes:194" },
	["Toothless"] = { sprite="ChatEmotes:195" },
	["Splorg"] = { sprite="ChatEmotes:196" },
	["pappyFace"] = { sprite="ChatEmotes:197" },
	["Komatakya"] = { sprite="ChatEmotes:198", sound="KomataKya" },
	["Kya"] = { sprite="ChatEmotes:198", sound="KomataKya" },
	["OMEGALUL"] = { sprite="ChatEmotes:199" },
	["PagChomp"] = { sprite="ChatEmotes:200" },
	["KKonaW"] = { sprite="ChatEmotes:201" },
	["LULW"] = { sprite="ChatEmotes:202" },
	["BeniFace"] = { sprite="ChatEmotes:203" },
	["TheRock"] = { sprite="ChatEmotes:204" },
	["haHAA"] = { sprite="ChatEmotes:205" },
	["ZULUL"] = { sprite="ChatEmotes:206" },
	["forsenE"] = { sprite="ChatEmotes:207" },
	["FrenchFlag"] = { sprite="ChatEmotes:208" },
	["Gameboy"] = { sprite="ChatEmotes:209", sound="Gameboy" },
	["Mugiwara"] = { sprite="ChatEmotes:210" },
	["thonking"] = { sprite="ChatEmotes:211" },
	["SynayaFace2"] = { sprite="ChatEmotes:212" },
	["withAgun"] = { sprite="ChatEmotes:213" },
	["monkaL"] = { sprite="ChatEmotes:214" },
	["rengeFlute"] = { sprite="ChatEmotes:215" },
	["PepoThink"] = { sprite="ChatEmotes:216" },
	["withAknife"] = { sprite="ChatEmotes:217" },
	["Emote"] = { sprite="ChatEmotes:218" },
	["weebSmug"] = { sprite="ChatEmotes:219" },
	["weebTea"] = { sprite="ChatEmotes:220" },
	["weebAngry"] = { sprite="ChatEmotes:221" },
	["weebHi"] = { sprite="ChatEmotes:222" },
	["Beni1"] = { sprite="ChatEmotes:223" },
	["Beni2"] = { sprite="ChatEmotes:224" },
	["Beni3"] = { sprite="ChatEmotes:225" },
	["Beni4"] = { sprite="ChatEmotes:226" },
	["FeelsDankMan"] = { sprite="ChatEmotes:227" },
	["FeelsOkayMan"] = { sprite="ChatEmotes:228" },
	["FeelsWhatMan"] = { sprite="ChatEmotes:229" },
	["monkaOMEGA"] = { sprite="ChatEmotes:230" },
	["PepeHands"] = { sprite="ChatEmotes:231" },
	["PepeLaugh"] = { sprite="ChatEmotes:232" },
	["PepoS"] = { sprite="ChatEmotes:233" },
	["REEee"] = { sprite="ChatEmotes:234" , sound="REEee" },
	["KMS"] = { sprite="ChatEmotes:235" },
	["SnappiPussy"] = { sprite="ChatEmotes:236" },
	["sweetFace"] = { sprite="ChatEmotes:237" },
	["SynayaFace"] = { sprite="ChatEmotes:238" , sound="walzy-3rd_world_retard" },
	["TriEasy"] = { sprite="ChatEmotes:239" },
	["Emote1"] = { sprite="ChatEmotes:240" },
	["Emote2"] = { sprite="ChatEmotes:241" },
	["monkaR"] = { sprite="ChatEmotes:242" },
	["coolHue"] = { sprite="ChatEmotes:243" },
	["hueFace"] = { sprite="ChatEmotes:244" },
	["withAgun1"] = { sprite="ChatEmotes:245" },
	["withAknife1"] = { sprite="ChatEmotes:246" },
	["Clap"] = { sprite="ChatEmotes:247" },
	["withCorn"] = { sprite="ChatEmotes:248" },
	["RarestParrot"] = { sprite="ChatEmotes:249" },
	["Pog"] = { sprite="ChatEmotes:250" },
	["Emote3"] = { sprite="ChatEmotes:251" },
	["Emote4"] = { sprite="ChatEmotes:252" },
	["FeelsAmazingMan"] = { sprite="ChatEmotes:253" },
	["miceraFace"] = { sprite="ChatEmotes:254" },
	["dogeChef"] = { sprite="ChatEmotes:255" },
	["ehalewhef"] = { sprite="ChatEmotes:256", height=20 },
	[":facepalm::skin-tone-5:"] = { sprite="ChatEmotes:257", width=62 },
	["FeelsDerpMan"] = { sprite="ChatEmotes:258" },
	["hueChef"] = { sprite="ChatEmotes:259" },
	["pappyChef"] = { sprite="ChatEmotes:260" },
	["whalechef"] = { sprite="ChatEmotes:261" },
	["SnappiPussyChef"] = { sprite="ChatEmotes:262" },
	["BabyChef"] = { sprite="ChatEmotes:263" },
	["ChefChef"] = { sprite="ChatEmotes:264" },
	["SynayaChef"] = { sprite="ChatEmotes:265" },
	["sweetChef"] = { sprite="ChatEmotes:266" },
	["monkaChef"] = { sprite="ChatEmotes:267" },
	["BibleChef"] = { sprite="ChatEmotes:268" },
	["SynayaFace3"] = { sprite="ChatEmotes:269" },
	["gudao"] = { sprite="ChatEmotes:270" },
	["SeemsGood"] = { sprite="ChatEmotes:271" },
	["PogChampO"] = { sprite="ChatEmotes:272" },
	["ChomPag"] = { sprite="ChatEmotes:272" },
	["elviraFace"] = { sprite="ChatEmotes:273" },
	["elviraW"] = { sprite="ChatEmotes:274" },
	["elviraMEGA"] = { sprite="ChatEmotes:275" },
	["shinjiLaugh"] = { sprite="ChatEmotes:276" },
	["4Heads"] = { sprite="ChatEmotes:277" },
	["4Headest"] = { sprite="ChatEmotes:278" },
	["4hEAD"] = { sprite="ChatEmotes:279" },
	["AYAYA"] = { sprite="ChatEmotes:280" },
	["HYPERBRUH"] = { sprite="ChatEmotes:281" },
	["HAhaa"] = { sprite="ChatEmotes:282" },
	["Kapp"] = { sprite="ChatEmotes:283" },
	["AngrySakura"] = { sprite="ChatEmotes:284" },
	["Nanachi"] = { sprite="ChatEmotes:285" , sound="Nanachi's Nah 1" },
	["Nanachi1"] = { sprite="ChatEmotes:285" , sound="Nanachi's Nah 2" },
	["Nanachi2"] = { sprite="ChatEmotes:285" , sound="Nanachi's Nah 3" },
	["Rikka"] = { sprite="ChatEmotes:286" , sound="Rikka ow" },
	["Itai"] = { sprite="ChatEmotes:287" , sound="Itai" },
	["muhSmug"] = { sprite="ChatEmotesTwitch:288" },
	["rooCop"] = { sprite="ChatEmotesTwitch:289" },
	["rooD"] = { sprite="ChatEmotesTwitch:290" },
	["rooEZ"] = { sprite="ChatEmotesTwitch:291" },
	["rooGasm"] = { sprite="ChatEmotesTwitch:292" },
	["rooHparpo"] = { sprite="ChatEmotesTwitch:293" },
	["rooHype"] = { sprite="ChatEmotesTwitch:294" },
	["rooLewd"] = { sprite="ChatEmotesTwitch:295" },
	["rooOhISam"] = { sprite="ChatEmotesTwitch:296" },
	["rooREE"] = { sprite="ChatEmotesTwitch:297" , sound="REEee" },
	["rooSip"] = { sprite="ChatEmotesTwitch:298" },
	["rooWut"] = { sprite="ChatEmotesTwitch:299" },
	["rooW"] = { sprite="ChatEmotesTwitch:300" },
    ["DainsGame"] = { sprite="ChatEmotesTwitch:301" },
	["PogChaarp"] = { sprite="ChatEmotesTwitch:302" },
	["VoltronFace"] = { sprite="ChatEmotesTwitch:303" },
	["GlacialFace"] = { sprite="ChatEmotesTwitch:304" },
}
local bNameEmote = false
local Jita = nil

-- Copied from ChatLog
local knSaveVersion = 8
local kstrColorChatRegular 		= "ff7fffb9"
local kstrColorChatShout		= "ffd9eef7"
local kstrColorChatRoleplay 	= "ff58e3b0"
local kstrColorNonSelectedEntry = "UI_BtnTextHoloNormal"
local kstrBubbleFont 			= "CRB_Dialog"
local kstrDialogFont 			= "CRB_Dialog"
local kstrDialogFontRP 			= "CRB_Dialog_I"
local kstrGMIcon 				= "Icon_Windows_UI_GMIcon"
local karEvalColors = {
	[Item.CodeEnumItemQuality.Inferior] 		= "ItemQuality_Inferior",
	[Item.CodeEnumItemQuality.Average] 			= "ItemQuality_Average",
	[Item.CodeEnumItemQuality.Good] 			= "ItemQuality_Good",
	[Item.CodeEnumItemQuality.Excellent] 		= "ItemQuality_Excellent",
	[Item.CodeEnumItemQuality.Superb] 			= "ItemQuality_Superb",
	[Item.CodeEnumItemQuality.Legendary] 		= "ItemQuality_Legendary",
	[Item.CodeEnumItemQuality.Artifact]		 	= "ItemQuality_Artifact",
}
local karChannelTypeToColor = {
	[ChatSystemLib.ChatChannel_Command] 		= { Channel = "ChannelCommand", 		},
	[ChatSystemLib.ChatChannel_System] 			= { Channel = "ChannelSystem", 			},
	[ChatSystemLib.ChatChannel_Debug] 			= { Channel = "ChannelDebug", 			},
	[ChatSystemLib.ChatChannel_Say] 			= { Channel = "ChannelSay", 			},
	[ChatSystemLib.ChatChannel_Yell] 			= { Channel = "ChannelShout", 			},
	[ChatSystemLib.ChatChannel_Whisper] 		= { Channel = "ChannelWhisper", 		},
	[ChatSystemLib.ChatChannel_Party] 			= { Channel = "ChannelParty", 			},
	[ChatSystemLib.ChatChannel_Emote] 			= { Channel = "ChannelEmote", 			},
	[ChatSystemLib.ChatChannel_AnimatedEmote] 	= { Channel = "ChannelEmote", 			},
	[ChatSystemLib.ChatChannel_Zone] 			= { Channel = "ChannelZone", 			},
	[ChatSystemLib.ChatChannel_ZoneGerman]		= { Channel = "ChannelZone", 			},
	[ChatSystemLib.ChatChannel_ZoneFrench]		= { Channel = "ChannelZone", 			},
	[ChatSystemLib.ChatChannel_ZonePvP] 		= { Channel = "ChannelPvP", 			},
	[ChatSystemLib.ChatChannel_Trade] 			= { Channel = "ChannelTrade",			},
	[ChatSystemLib.ChatChannel_Guild] 			= { Channel = "ChannelGuild", 			},
	[ChatSystemLib.ChatChannel_GuildOfficer] 	= { Channel = "ChannelGuildOfficer",	},
	[ChatSystemLib.ChatChannel_Society] 		= { Channel = "ChannelCircle2",			},
	[ChatSystemLib.ChatChannel_Custom] 			= { Channel = "ChannelCustom", 			},
	[ChatSystemLib.ChatChannel_NPCSay] 			= { Channel = "ChannelNPC", 			},
	[ChatSystemLib.ChatChannel_NPCYell] 		= { Channel = "ChannelNPC",		 		},
	[ChatSystemLib.ChatChannel_NPCWhisper]		= { Channel = "ChannelNPC", 			},
	[ChatSystemLib.ChatChannel_Datachron] 		= { Channel = "ChannelNPC", 			},
	[ChatSystemLib.ChatChannel_Combat] 			= { Channel = "ChannelGeneral", 		},
	[ChatSystemLib.ChatChannel_Realm] 			= { Channel = "ChannelSupport", 		},
	[ChatSystemLib.ChatChannel_Loot] 			= { Channel = "ChannelLoot", 			},
	[ChatSystemLib.ChatChannel_PlayerPath] 		= { Channel = "ChannelGeneral", 		},
	[ChatSystemLib.ChatChannel_Instance] 		= { Channel = "ChannelInstance", 		},
	[ChatSystemLib.ChatChannel_WarParty] 		= { Channel = "ChannelWarParty",		},
	[ChatSystemLib.ChatChannel_WarPartyOfficer] = { Channel = "ChannelWarPartyOfficer", },
	[ChatSystemLib.ChatChannel_Nexus] 			= { Channel = "ChannelNexus", 			},
	[ChatSystemLib.ChatChannel_NexusGerman]		= { Channel = "ChannelNexus", 			},
	[ChatSystemLib.ChatChannel_NexusFrench]		= { Channel = "ChannelNexus", 			},
	[ChatSystemLib.ChatChannel_AccountWhisper] 	= { Channel = "ChannelAccountWisper", 	},
	[ChatSystemLib.ChatChannel_Community]		= { Channel = "ChannelCommunity",		},
}

-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function ChatEmotes:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here
	self.soundEnable = true
	self.settings = {
		sound = true,
		soundcd = 10,
		name = false
	}
	
    return o
end

function ChatEmotes:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end

-----------------------------------------------------------------------------------------------
-- ChatEmotes OnLoad
-----------------------------------------------------------------------------------------------
function ChatEmotes:OnLoad()
	self:InitializeHooks()
	
	Apollo.LoadSprites("Sprites.xml")
	
	Apollo.RegisterEventHandler("CET_Sound", "OnSound", self)
	Apollo.RegisterSlashCommand("cet", "OnSlashCommand", self)
	Apollo.RegisterSlashCommand("ac", "OnSlashCommand", self)
end

function ChatEmotes:InitializeHooks()
	local crb = Apollo.GetAddon("ChatLog")
	if crb ~= nil then
		crb.HelperGenerateChatMessage = self.HelperGenerateChatMessage
		crb.OnRestore = self.OnRestoreFix
	end
	local eveo = Apollo.GetAddon("Jita")
	if eveo ~= nil then
		Jita = eveo
		eveo:Extend("ChatWindow").GenerateChatMessageGeneric = self.GenerateChatMessageGeneric
	end
end

-----------------------------------------------------------------------------------------------
-- ChatEmotes Settings
-----------------------------------------------------------------------------------------------
function ChatEmotes:OnSlashCommand(slash, args)
	local arg = args:gmatch([[[^%s]+]])
	local cmd = arg()
	local cmd = cmd and cmd:lower() or ""
	local arg1 = arg()
	local arg1 = arg1 and arg1:lower() or ""
	
	if cmd == "sound" then
		self.settings.sound = not self.settings.sound
		Print(("Playing sounds: %s"):format(tostring(self.settings.sound)))
	elseif cmd == "soundcd" then
		local newcd = tonumber(arg1)
		if type(newcd) == "number" then
			self.settings.soundcd = newcd
		end
		Print(("Sound CD is: %ss"):format(tostring(self.settings.soundcd)))
	elseif cmd == "name" then
		self.settings.name = not self.settings.name
		bNameEmote = self.settings.name
		Print(("Using emotes in names: %s"):format(tostring(self.settings.name)))
	else
		Print(("/%s [command]"):format(slash))
		Print("Available commands:")
		Print("sound  - toggle emote sounds")
		Print("soundcd [seconds]  - set cooldown on sounds")
		Print("name   - toggle emotes in names")
	end
end

function ChatEmotes:OnSave(eType)
	if eType ~= GameLib.CodeEnumAddonSaveLevel.Account then
		return
	end

	return self.settings
end

function ChatEmotes:OnRestore(eType, tSavedData)
	if eType ~= GameLib.CodeEnumAddonSaveLevel.Account then
		return
	end

	for key, value in pairs(tSavedData) do
		self.settings[key] = value
	end
	
	bNameEmote = self.settings.name
end

-----------------------------------------------------------------------------------------------
-- ChatEmotes Functions
-----------------------------------------------------------------------------------------------
function ChatEmotes:OnRestoreFix(eType, tSavedData)
	if not tSavedData or tSavedData.nVersion ~= knSaveVersion then
		return
	end

	if tSavedData.bEnableNCFade ~= nil then
		self.bEnableNCFade = tSavedData.bEnableNCFade
	end
	if tSavedData.bEnableBGFade ~= nil then
		self.bEnableBGFade = tSavedData.bEnableBGFade
	end
	if tSavedData.nBGOpacity ~= nil then
		self.nBGOpacity = tSavedData.nBGOpacity
	end
	if tSavedData.bShowChannel ~= nil then
		self.bShowChannel = tSavedData.bShowChannel
	end
	if tSavedData.bShowTimestamp ~= nil then
		self.bShowTimestamp = tSavedData.bShowTimestamp
	end
	if tSavedData.bProfanityFilter ~= nil then
		self.bProfanityFilter = tSavedData.bProfanityFilter
	end
	if tSavedData.eRoleplayOption ~= nil then
		self.eRoleplayOption = tSavedData.eRoleplayOption
	end
	if tSavedData.bEnableChatLineFade ~= nil then
		self.bEnableChatLineFade = tSavedData.bEnableChatLineFade
	end
	
	self.nFontSize = tSavedData.nFontSize
	if tSavedData.tWindow and #tSavedData.tWindow > 0 then
		self.tWindow = tSavedData.tWindow
	end
end

function ChatEmotes:OnSound(file)
	if self.settings.sound and self.soundEnable then
		Sound.PlayFile("Sound\\" .. file .. ".wav")
		if self.settings.soundcd > 0 then
			self.soundEnable = false
			self.soundTimer = ApolloTimer.Create(self.settings.soundcd, false, "OnSoundEnable", self)
		end
	end
end

function ChatEmotes:OnSoundEnable()
	self.soundEnable = true
end

function ChatEmotes:HelperGenerateChatMessage(tQueuedMessage)
	if tQueuedMessage.xml then
		return
	end

	local eChannelType = tQueuedMessage.eChannelType
	local tMessage = tQueuedMessage.tMessage

	-- Different handling for combat log
	if eChannelType == ChatSystemLib.ChatChannel_Combat then
		-- no formats in combat, roll it all up into one.
		local strMessage = ""
		for idx, tSegment in ipairs(tMessage.arMessageSegments) do
			strMessage = strMessage .. tSegment.strText
		end
		tQueuedMessage.strMessage = strMessage
		return
	end

	local xml = XmlDoc.new()

	local crText = self.arChatColor[eChannelType] or ApolloColor.new("white")
	local crChannel = ApolloColor.new(karChannelTypeToColor[eChannelType].Channel or "white")
	local crPlayerName = nil
	if tMessage.bCrossFaction then
		crPlayerName = ApolloColor.new("ChatPlayerNameHostile")
	else
		crPlayerName = ApolloColor.new("ChatPlayerName")
	end

	local strTime = ""
	if self.bShowTimestamp then
		strTime = self:HelperGetTimeStr()
	end

	local strWhisperName = tMessage.strSender
	if tMessage.strRealmName:len() > 0 and eChannelType ~= ChatSystemLib.ChatChannel_AccountWhisper then
		-- Name/Realm formatting needs to be very specific for cross realm chat to work
		strWhisperName = strWhisperName .. "@" .. tMessage.strRealmName
	end
	local strDisplayName = strWhisperName

	--strWhisperName must only be sender@realm, or friends equivelent name.

	local strPresenceState = ""
	if tMessage.bAutoResponse then
		strPresenceState = '('..Apollo.GetString("AutoResponse_Prefix")..')'
	end

	if tMessage.nPresenceState == FriendshipLib.AccountPresenceState_Away then
		strPresenceState = '<'..Apollo.GetString("Command_Friendship_AwayFromKeyboard")..'>'
	elseif tMessage.nPresenceState == FriendshipLib.AccountPresenceState_Busy then
		strPresenceState = '<'..Apollo.GetString("Command_Friendship_DoNotDisturb")..'>'
	end

	if eChannelType == ChatSystemLib.ChatChannel_Whisper then
		if not tMessage.bSelf then
			self.tLastWhisperer = { strCharacterName = strWhisperName, eChannelType = ChatSystemLib.ChatChannel_Whisper }--record the last incoming whisperer for quick response
		end
		Sound.Play(Sound.PlayUISocialWhisper)
		self:InsertIntoRecent(strWhisperName, false)
	elseif eChannelType == ChatSystemLib.ChatChannel_AccountWhisper then

		local tPreviousWhisperer = self.tLastWhisperer

		local tAccountFriends = FriendshipLib.GetAccountList()
		for idx, tAccountFriend in pairs(tAccountFriends) do
			if tAccountFriend.arCharacters ~= nil then
				for idx, tCharacter in pairs(tAccountFriend.arCharacters) do
					if tCharacter.strCharacterName == tMessage.strSender and (tMessage.strRealmName:len() == 0 or tCharacter.strRealm == tMessage.strRealmName) then
						if not tMessage.bSelf or (tPreviousWhisperer and tPreviousWhisperer.strCharacterName == tMessage.strSender) then
							self.tLastWhisperer =
							{
								strCharacterName = tMessage.strSender,
								strRealmName = tCharacter.strRealm,
								strDisplayName = tAccountFriend.strCharacterName,
								eChannelType = ChatSystemLib.ChatChannel_AccountWhisper
							}
						end
						strDisplayName = tAccountFriend.strCharacterName
					end
				end
			end
		end
		Sound.Play(Sound.PlayUISocialWhisper)
		self:InsertIntoRecent(strDisplayName, true)
	end

	-- We build strings backwards, right to left
	if eChannelType == ChatSystemLib.ChatChannel_AnimatedEmote then -- emote animated channel gets special formatting
		xml:AddLine(strTime, crChannel, self.strFontOption, "Left")

	elseif eChannelType == ChatSystemLib.ChatChannel_Emote then -- emote channel gets special formatting
		xml:AddLine(strTime, crChannel, self.strFontOption, "Left")
		if strDisplayName:len() > 0 then
			if tMessage.bGM then
				xml:AppendImage(kstrGMIcon, 16, 16)
			end
			local strCross = tMessage.bCrossFaction and "true" or "false"--has to be a string or a number due to code restriction
			xml:AppendText(strDisplayName, crPlayerName, self.strFontOption, {strCharacterName = strWhisperName, nReportId = tMessage.nReportId, strCrossFaction = strCross}, "Source")
		end
		xml:AppendText(" ")
	else
		local strChannel
		if eChannelType == ChatSystemLib.ChatChannel_Society then
			strChannel = (string.format("%s ", String_GetWeaselString(Apollo.GetString("ChatLog_GuildCommand"), tQueuedMessage.strChannelName, tQueuedMessage.strChannelCommand))) --String DB removed empty characters at the end of string, so have to hardcode it here.
		else
			strChannel = String_GetWeaselString(Apollo.GetString("CRB_Brackets_Space"), tQueuedMessage.strChannelName)
		end

		if self.bShowChannel ~= true then
			strChannel = ""
		end

		xml:AddLine(strTime .. strChannel, crChannel, self.strFontOption, "Left")
		if strDisplayName:len() > 0 then

			local strWhisperNamePrefix = ""
			if eChannelType == ChatSystemLib.ChatChannel_Whisper or eChannelType == ChatSystemLib.ChatChannel_AccountWhisper then
				if tMessage.bSelf then
					strWhisperNamePrefix = Apollo.GetString("ChatLog_To")
				else
					strWhisperNamePrefix = Apollo.GetString("ChatLog_From")
				end
			end

			xml:AppendText( strWhisperNamePrefix, crText, self.strFontOption)

			if tMessage.bGM then
				xml:AppendImage(kstrGMIcon, 20, 19)
			end

			local strCross = tMessage.bCrossFaction and "true" or "false"--has to be a string or a number due to code restriction
			
			-- Emote replace in name
			if bNameEmote then
				for word in strDisplayName:gmatch("%S+") do
					if tEmoticons[word] then
						local emote = tEmoticons[word]
						local s, e = strDisplayName:find(word, 1, true)
						local y = 18
						local x = 22
						
						if emote.width then x = emote.width end
						--if emote.sound then Event_FireGenericEvent("CET_Sound", emote.sound) end
						
						xml:AppendText(strDisplayName:sub(1, s-1), crPlayerName, self.strFontOption, {strCharacterName = strWhisperName, nReportId = tMessage.nReportId , strCrossFaction = strCross}, "Source")
						xml:AppendImage(emote.sprite, x, y)

						strDisplayName = strDisplayName:sub(e+1)
					end
				end
			end
			
			xml:AppendText( strDisplayName, crPlayerName, self.strFontOption, {strCharacterName = strWhisperName, nReportId = tMessage.nReportId , strCrossFaction = strCross}, "Source")
		end
		xml:AppendText( strPresenceState .. Apollo.GetString("Chat_ColonBreak"), crChannel, self.strFontOption, "Left")
	end

	local xmlBubble = nil
	if tMessage.bShowChatBubble then
		xmlBubble = XmlDoc.new() -- This is the speech bubble form
		xmlBubble:AddLine("", crChannel, self.strFontOption, "Center")
		--[[  DEBUG
		local strMessage = ""
		for idx, tSegment in ipairs(tMessage.arMessageSegments) do
			strMessage = strMessage .. " | " .. tSegment.strText
		end
		xmlBubble:AppendText(strMessage, crBubbleText, strBubbleFont)
		tQueuedMessage.bHasVisibleText = bHasVisibleText
		tQueuedMessage.xmlBubble = xmlBubble
		return
		]]--
	end

	local bHasVisibleText = false
	for idx, tSegment in ipairs( tMessage.arMessageSegments ) do
		local strText = tSegment.strText
		local bAlien = tSegment.bAlien
		local bShow = false

		if self.eRoleplayOption == 3 then
			bShow = not tSegment.bRolePlay
		elseif self.eRoleplayOption == 2 then
			bShow = tSegment.bRolePlay
		else
			bShow = true;
		end

		if bShow then
			local crChatText = crText;
			local crBubbleText = kstrColorChatRegular
			local strChatFont = self.strFontOption
			local strBubbleFont = kstrBubbleFont
			local tLink = {}


			if tSegment.uItem ~= nil then -- item link
				-- replace me with correct colors
				strText = String_GetWeaselString(Apollo.GetString("CRB_Brackets"), tSegment.uItem:GetName())
				crChatText = karEvalColors[tSegment.uItem:GetItemQuality()]
				crBubbleText = ApolloColor.new("white")

				tLink.strText = strText
				tLink.uItem = tSegment.uItem

			elseif tSegment.uQuest ~= nil then -- quest link
				-- replace me with correct colors
				strText = String_GetWeaselString(Apollo.GetString("CRB_Brackets"), tSegment.uQuest:GetTitle())
				crChatText = ApolloColor.new("green")
				crBubbleText = ApolloColor.new("green")

				tLink.strText = strText
				tLink.uQuest = tSegment.uQuest

			elseif tSegment.uArchiveArticle ~= nil then -- archive article
				-- replace me with correct colors
				strText = String_GetWeaselString(Apollo.GetString("CRB_Brackets"), tSegment.uArchiveArticle:GetTitle())
				crChatText = ApolloColor.new("ffb7a767")
				crBubbleText = ApolloColor.new("ffb7a767")

				tLink.strText = strText
				tLink.uArchiveArticle = tSegment.uArchiveArticle
				
			elseif tSegment.tNavPoint ~= nil then
				-- replace me with correct colors
				strText = String_GetWeaselString(Apollo.GetString("CRB_Brackets"), "NavPoint")
				crChatText = ApolloColor.new("blue")
				crBubbleText = ApolloColor.new("blue")

				tLink.strText = strText
				tLink.tNavPoint = tSegment.tNavPoint
				
			else
				if tSegment.bRolePlay then
					crBubbleText = kstrColorChatRoleplay
					strChatFont = self.strRPFontOption
					strBubbleFont = kstrDialogFontRP
				end

				if bAlien or tSegment.bProfanity then -- Weak filter. Note only profanity is scrambled.
					strChatFont = self.strAlienFontOption
					strBubbleFont = self.strAlienFontOption
				end
			end

			-- Emote replace
			for word in strText:gmatch("%S+") do
				if tEmoticons[word] then
					local emote = tEmoticons[word]
					local s, e = strText:find(word, 1, true)
					local y = 18
					local x = 22
					
					if emote.width then x = emote.width end
					if emote.sound then Event_FireGenericEvent("CET_Sound", emote.sound) end
					
					xml:AppendText(strText:sub(1, s-1), crChatText, strChatFont)
					xml:AppendImage(emote.sprite, x, y)
					
					if xmlBubble then
						xmlBubble:AppendText(strText:sub(1, s-1), crBubbleText, strBubbleFont)
						xmlBubble:AppendImage(emote.sprite, x, y)
					end
					
					strText = strText:sub(e+1)
				end
			end
			
			if next(tLink) == nil then
				if eChannelType == ChatSystemLib.ChatChannel_AnimatedEmote then
					local strCross = tMessage.bCrossFaction and "true" or "false"--has to be a string or a number due to code restriction
					xml:AppendText(strText, crChatText, strChatFont, {strCharacterName = strWhisperName, nReportId = tMessage.nReportId, strCrossFaction = strCross}, "Source")
				else
					xml:AppendText(strText, crChatText, strChatFont)
				end
			else
				local strLinkIndex = tostring( self:HelperSaveLink(tLink) )
				-- append text can only save strings as attributes.
				xml:AppendText(strText, crChatText, strChatFont, {strIndex=strLinkIndex} , "Link")
			end

			if xmlBubble then
				xmlBubble:AppendText(strText, crBubbleText, strBubbleFont) -- Format for bubble; regular
			end

			bHasVisibleText = bHasVisibleText or self:HelperCheckForEmptyString(strText)
		end
	end

	tQueuedMessage.bHasVisibleText = bHasVisibleText
	tQueuedMessage.xml = xml
	tQueuedMessage.xmlBubble = xmlBubble
end

function ChatEmotes:GenerateChatMessageGeneric(message)
	if message.XmlObj then
		return message.XmlObj
	end

	local channel = Jita.Client.Channels[message.Channel]

	local channelType    = channel:GetType()
	local channelName    = channel:GetName()
	local channelCommand = channel:GetCommand()
	local channelAbbr    = channel:GetAbbreviation()
	local content        = message.Content

	channelAbbr = Jita.Consts.ChatChannelsAbbreviations[channelType] or channelAbbr

	local xmlPlayerName = XmlDoc.new()
	local xmlLine       = XmlDoc.new()

	local crText    = Jita.Consts.ChatMessagesColors[channelType] or ApolloColor.new("white")
	local crChannel = Jita.Consts.ChatMessagesColors[channelType] or ApolloColor.new("white")

	local crPlayerName = ApolloColor.new("ChatPlayerName")

	if content.bCrossFaction then
		crPlayerName = ApolloColor.new("ChatPlayerNameHostile")
	end

	local strCharacterName       = content.strSender
	local strDisplayName         = content.strDisplayName 

	local strAWPeerCharacterName = content.strAWPeerCharacterName
	local strAWPeerDisplayName   = content.strAWPeerDisplayName

	local source = {
		strCharacterName = strCharacterName,
		nReportId        = content.nReportId,
		strCrossFaction  = content.bCrossFaction and "true" or "false" 
	}

	if content.bSelf 
	and self.StreamType == Jita.Client.EnumStreamsTypes.SEGREGATED
	and Jita.Player.Name
	then
		source.strCharacterName = Jita.Player.Name
		source.nReportId        = nil
		source.strCrossFaction  = "false" 
	end

	--

	xmlLine:AddLine("", crChannel, self.MessageTextFont, "Left")
	xmlPlayerName:AddLine("", crPlayerName, self.MessageTextFont, "Left")

	-- Keepme:
	-- xmlLine:AppendText("#" .. message.ID .. " ", crChannel, self.MessageTextFont, "Left")

	local strTime = ""

	if self.MessageDisplayMode == 'Inline' and Jita.UserSettings.ChatWindow_MessageShowTimestamp == true then
		strTime = message.StrTime

		if self.StreamType == Jita.Client.EnumStreamsTypes.SEGREGATED then
			strTime = "[" .. message.StrTime .. "]"
		end

		xmlLine:AppendText(strTime .. " ", crChannel, self.MessageTextFont, "Left")
	end

	if Jita.UserSettings.ChatWindow_MessageShowPlayerRange == true
	and not content.bSelf
	and message.Range
	and message.Range > 0
	then
		xmlLine:AppendText("[" .. message.Range .. "m] ", "ChatEmote", "CRB_Pixel", "Left")
	end

	if self.MessageDisplayMode == 'Block' then
		xmlPlayerName:AppendText(strDisplayName, crPlayerName, self.MessageTextFont, source, "Source")

		if content.bGM then
			xmlPlayerName:AppendText(" ")
			xmlPlayerName:AppendImage(Jita.Consts.kstrGMIcon, 20, 19)
		end
	end

	-- emote channels gets special formatting
	if channelType == ChatSystemLib.ChatChannel_Emote 
	or channelType == ChatSystemLib.ChatChannel_AnimatedEmote
	then
		if strDisplayName:len() > 0 then
			if content.bGM and self.MessageDisplayMode == 'Inline' then
				xmlPlayerName:AppendImage(Jita.Consts.kstrGMIcon, 16, 16)
				xmlPlayerName:AppendText(" ")
			end

			-- only non-animated emotes get player name appended 
			if channelType == ChatSystemLib.ChatChannel_Emote then
				xmlLine:AppendText(strDisplayName, crPlayerName, self.MessageTextFont, source, "Source")
				xmlLine:AppendText(" ")
			end
		end
	else
		local strChannel = ""

		if channelType == ChatSystemLib.ChatChannel_Society
		or channelType == ChatSystemLib.ChatChannel_Custom
		then
			if Jita.UserSettings.ChatWindow_MessageUseChannelAbbr == true then
				strChannel = (string.format("%s ", String_GetWeaselString(Apollo.GetString("ChatLog_GuildCommand"), string.upper(string.sub(channelName, 1, 1)) , channelCommand)))
			else
				strChannel = (string.format("%s ", String_GetWeaselString(Apollo.GetString("ChatLog_GuildCommand"), channelName, channelCommand)))
			end
		else
			if Jita.UserSettings.ChatWindow_MessageUseChannelAbbr == true
			and channelAbbr ~= ''
			then
				strChannel = String_GetWeaselString(Apollo.GetString("CRB_Brackets_Space"), string.upper(channelAbbr))
			else
				strChannel = String_GetWeaselString(Apollo.GetString("CRB_Brackets_Space"), channelName)
			end
		end

		if Jita.UserSettings.ChatWindow_MessageShowChannelName == true
		or self.StreamType == Jita.Client.EnumStreamsTypes.AGGREGATED -- on aggregated mode we show channel because "the obs"
		then
			xmlPlayerName:AppendText(" @ ", "ChatEmote", self.MessageTextFont, "Left")
			xmlPlayerName:AppendText(strChannel, crChannel, self.MessageTextFont, "Left")

			if self.MessageDisplayMode == 'Inline' then
				xmlLine:AppendText(strChannel, crChannel, self.MessageTextFont, "Left")
			end
		end

		local strPresenceState = ""

		if content.bAutoResponse then
			strPresenceState = '('..Apollo.GetString("AutoResponse_Prefix")..')'
		end

		if content.nPresenceState == FriendshipLib.AccountPresenceState_Away then
			strPresenceState = '<'..Apollo.GetString("Command_Friendship_AwayFromKeyboard")..'>'
		elseif content.nPresenceState == FriendshipLib.AccountPresenceState_Busy then
			strPresenceState = '<'..Apollo.GetString("Command_Friendship_DoNotDisturb")..'>'
		end

		if strDisplayName:len() > 0 then
			if self.MessageDisplayMode == 'Inline' then
				if content.bGM then
					xmlLine:AppendImage(Jita.Consts.kstrGMIcon, 20, 19)
					xmlLine:AppendText(" ")
				end

				if self.StreamType == Jita.Client.EnumStreamsTypes.AGGREGATED 
				and (channelType == ChatSystemLib.ChatChannel_Whisper or channelType == ChatSystemLib.ChatChannel_AccountWhisper)
				and content.bSelf
				and content.strSender
				then
					xmlLine:AppendText(Apollo.GetString("ChatLog_To"), crChannel, self.MessageTextFont, "Left")

					if channelType == ChatSystemLib.ChatChannel_AccountWhisper
					and strAWPeerDisplayName
					and strAWPeerDisplayName:len() > 0
					then
						xmlLine:AppendText(strAWPeerDisplayName, crPlayerName, self.MessageTextFont, source, "Source")
					else
						xmlLine:AppendText(content.strSender, crPlayerName, self.MessageTextFont, source, "Source")
					end
				else
					xmlLine:AppendText(strDisplayName, crPlayerName, self.MessageTextFont, source, "Source")
				end

				xmlLine:AppendText(strPresenceState .. Apollo.GetString("Chat_ColonBreak"), crChannel, self.MessageTextFont, "Left")
			end
		end
	end

	local xmlBubble = nil

	if Jita.UserSettings.ChatWindow_MessageShowBubble == true then
		xmlBubble = XmlDoc.new()

		xmlBubble:AddLine("", crChannel, self.MessageTextFont, "Center")
	end

	--

	local bHasVisibleText = false

	for idx, tSegment in ipairs(content.arMessageSegments) do
		local strText       = tSegment.strText 
		local bAlien        = tSegment.bAlien
		local bShow         = false

		if Jita.UserSettings.ChatWindow_MessageHighlightRolePlay == true
		and strText and strText:len() > 0
		then
			strText = string.gsub(strText, "  "    , " ")
			strText = string.gsub(strText, "%-%-"  , "—")
			strText = string.gsub(strText, "%. "   , ".  ")
			strText = string.gsub(strText, "%! "   , "!  ")
			strText = string.gsub(strText, "%? "   , "?  ")
			strText = string.gsub(strText, "%.%.%.", "…")
		end

		if self.eRoleplayOption == 3 then
			bShow = not tSegment.bRolePlay
		elseif self.eRoleplayOption == 2 then
			bShow = tSegment.bRolePlay
		else
			bShow = true;
		end

		if bShow then
			local crChatText = crText;
			local crBubbleText = Jita.Consts.kstrColorChatRegular
			local strChatFont = self.MessageTextFont
			local strBubbleFont = Jita.Consts.kstrBubbleFont
			local tLink = {}

			if tSegment.uItem ~= nil then -- item link
				-- replace me with correct colors
				strText = String_GetWeaselString(Apollo.GetString("CRB_Brackets"), tSegment.uItem:GetName())
				crChatText = Jita.Consts.karEvalColors[tSegment.uItem:GetItemQuality()]
				crBubbleText = ApolloColor.new("white")

				tLink.strText = strText
				tLink.uItem = tSegment.uItem

			elseif tSegment.uQuest ~= nil then -- quest link
				-- replace me with correct colors
				strText = String_GetWeaselString(Apollo.GetString("CRB_Brackets"), tSegment.uQuest:GetTitle())
				crChatText = ApolloColor.new("green")
				crBubbleText = ApolloColor.new("green")

				tLink.strText = strText
				tLink.uQuest = tSegment.uQuest

			elseif tSegment.uArchiveArticle ~= nil then -- archive article
				-- replace me with correct colors
				strText = String_GetWeaselString(Apollo.GetString("CRB_Brackets"), tSegment.uArchiveArticle:GetTitle())
				crChatText = ApolloColor.new("ffb7a767")
				crBubbleText = ApolloColor.new("ffb7a767")

				tLink.strText = strText
				tLink.uArchiveArticle = tSegment.uArchiveArticle

			elseif tSegment.tNavPoint ~= nil then
				-- replace me with correct colors
				strText = String_GetWeaselString(Apollo.GetString("CRB_Brackets"), "NavPoint")
				crChatText = ApolloColor.new("ffb7a767")
				crBubbleText = ApolloColor.new("ffb7a767")

				tLink.strText = strText
				tLink.tNavPoint = tSegment.tNavPoint

			else
				if tSegment.bRolePlay then
					crBubbleText  = Jita.Consts.kstrColorChatRoleplay
					strChatFont   = self.MessageTextFont
					strBubbleFont = Jita.Consts.kstrDialogFontRP
				end

				if bAlien or tSegment.bProfanity then -- Weak filter. Note only profanity is scrambled.
					strChatFont   = "CRB_AlienMedium"
					strBubbleFont = "CRB_AlienMedium"
				end

				if message.Range ~= nil
				and message.Range > Jita.UserSettings.ChatWindow_SayEmoteRange
				and Jita.UserSettings.ChatWindow_MessageAlienateOutOfRange == true
				then
					strChatFont   = "CRB_AlienMedium"
					strBubbleFont = "CRB_AlienMedium"
				end
			end

			-- Emote replace
			for word in strText:gmatch("%S+") do
				if tEmoticons[word] then
					local emote = tEmoticons[word]
					local s, e = strText:find(word, 1, true)
					local y = 18
					local x = 22
					
					if emote.width then x = emote.width end
					if emote.sound then Event_FireGenericEvent("CET_Sound", emote.sound) end
					
					xmlLine:AppendText(strText:sub(1, s-1), crChatText, strChatFont)
					xmlLine:AppendImage(emote.sprite, x, y)
					
					if xmlBubble then
						xmlBubble:AppendText(strText:sub(1, s-1), crBubbleText, strBubbleFont)
						xmlBubble:AppendImage(emote.sprite, x, y)
					end
					
					strText = strText:sub(e+1)
				end
			end
			
			if next(tLink) == nil then 
				local highlights = self:HighlightChatMessageContent(strText, channelType)

				if highlights then
					for _, part in ipairs(highlights) do
						local hText  = part[1]
						local hColor = Jita.Consts.ChatMessagesColors[part[2]] or crChatText
						local hType  = part[3]

						if hType and hType == "URL" then
							xmlLine:AppendText(hText, hColor, strChatFont, {URL = hText}, "URL")
						else
							xmlLine:AppendText(hText, hColor, strChatFont)
						end
					end
				else
					xmlLine:AppendText(strText, crChatText, strChatFont)
				end
			else
				local strLinkIndex = tostring(self:HelperSaveLink(tLink))

				xmlLine:AppendText(strText, crChatText, strChatFont, {strIndex = strLinkIndex}, "Link")
			end

			if xmlBubble then
				xmlBubble:AppendText(strText, crBubbleText, strBubbleFont) -- Format for bubble; regular
			end

			bHasVisibleText = bHasVisibleText or Jita.Utils:StringEmpty(strText)
		end
	end

	message.XmlObj = 
	{
		XmlPlayerName  = xmlPlayerName  ,
		XmlLine        = xmlLine        ,
		XmlBubble      = xmlBubble      ,
		HasVisibleText = bHasVisibleText
	}

	return message.XmlObj
end


-----------------------------------------------------------------------------------------------
-- ChatEmotes Instance
-----------------------------------------------------------------------------------------------
local ChatEmotesInst = ChatEmotes:new()
ChatEmotesInst:Init()
